@Library('js-jenkins-library')

def dockerContainerName = 'js-application'

pipeline {
    environment {
        IMAGE_NAME = ''
    }
    agent any
    tools {nodejs "nodejs"}
    stages {
        stage('Build') {
            steps {
                script {
                    dir('app') {
                        npmInstall()
                    }
                }
            }
        }
        stage('Test') {
            steps {
                script {
                    dir('app') {
                        testing()
                    }
                }
            }
        }
        stage('Increment version') {
            steps {
                script {
                    dir('app') {
                        IMAGE_NAME = retrievingVersion()
                    }
                }
            }
        }
        stage('Build image') {
            when {
                expression {
                    BRANCH_NAME == 'master'
                }
            }
            steps {
                dockerLogin()
                buildImage "tmoretto17/my-app:$IMAGE_NAME"
                dockerPush "tmoretto17/my-app:$IMAGE_NAME"
            }
        }
        stage('Version update') {
            steps {
                script {
                    dir('app') {
                        incrementVersion()
                    }
                    commitAndPush "gitlab.com/moretto.tommaso/js-docker.git"
                }
            }
        }
        stage("deploy") {
            when {
                expression {
                    BRANCH_NAME == 'master'
                }
            }
            steps {
                script {
                    dockerCompose(IMAGE_NAME, 'ec2-server-key', "ec2-user@3.126.146.191")
                    /*def shellCmd = "bash ./server-cmds.sh ${IMAGE_NAME}"

                    sshagent(['ec2-server-key']) {
                        sh "scp server-cmds.sh ec2-user@3.126.146.191:/home/ec2-user"
                        sh "scp docker-compose.yaml ec2-user@3.126.146.191:/home/ec2-user"
                        sh "ssh -o StrictHostKeyChecking=no ec2-user@3.126.146.191 ${shellCmd}"
                    }*/
                }
            }
        }
    }
}
